/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1"
#define KEYPATH     "Software\\Nicely Crafted Entertainment\\Time of Defiance (CLIENT)"
#define BUFFSZ      512



void tod_pwd(u_char *pwd, int encnum);



int main(void) {
    HKEY    key;
    u_char  buff[BUFFSZ];
    int     len;


    setbuf(stdout, NULL);

    fputs("\n"
        "Time of Defiance password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(RegOpenKeyEx(HKEY_CURRENT_USER, KEYPATH, 0, KEY_READ, &key)) {
        fputs("\n"
            "Error: registry key has not been found\n"
            "       Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    len = BUFFSZ;
    if(RegQueryValueEx(
      key,
      "Bc_code",
      NULL,
      NULL,
      buff,
      (void *)&len)) {
        fputs("\n"
            "Error: password is not stored.\n"
            "       Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }
    RegCloseKey(key);

    tod_pwd(buff, 0x3f);

    printf("\n"
        "Password:   %s\n"
        "\n"
        "Press RETURN to exit\n",
        buff);
    fgetc(stdin);
    return(0);
}



void tod_pwd(u_char *pwd, int encnum) {
    u_char  *out,
            *ptr;
    int     len;

    len = strlen(pwd) >> 1;
    out = ptr = pwd;
    while(len--) {
        *out++ = ((ptr[0] - 'A') << 4) + (ptr[1] - 'a');
        ptr += 2;
    }
    len = out - pwd;
    if(!encnum) encnum = 0x3f;  // default for passwords
    while(len--) {
        *pwd = ((encnum & *pwd) ^ 0xff) & (encnum | *pwd);
        pwd++;
    }
    *pwd = 0;
}

